diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/three-gpp-http-client.cc ns-3.44/src/applications/model/three-gpp-http-client.cc
--- ns-3.43/src/applications/model/three-gpp-http-client.cc	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/three-gpp-http-client.cc	2025-03-09 16:55:49.347370900 -0700
@@ -761,21 +762,19 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_state == EXPECTING_EMBEDDED_OBJECT || m_state == PARSING_MAIN_OBJECT)
-    {
-        const Time readingTime = m_httpVariables->GetReadingTime();
-        NS_LOG_INFO(this << " Client will finish reading this web page in "
-                         << readingTime.As(Time::S) << ".");
-
-        // Schedule a request of another main object once the reading time expires.
-        m_eventRequestMainObject =
-            Simulator::Schedule(readingTime, &ThreeGppHttpClient::RequestMainObject, this);
-        SwitchToState(READING);
-    }
-    else
+    if (m_state != EXPECTING_EMBEDDED_OBJECT && m_state != PARSING_MAIN_OBJECT)
     {
         NS_FATAL_ERROR("Invalid state " << GetStateString() << " for EnterReadingTime().");
     }
+
+    const auto readingTime = m_httpVariables->GetReadingTime();
+    NS_LOG_INFO(this << " Client will finish reading this web page in " << readingTime.As(Time::S)
+                     << ".");
+
+    // Schedule a request of another main object once the reading time expires.
+    m_eventRequestMainObject =
+        Simulator::Schedule(readingTime, &ThreeGppHttpClient::RequestMainObject, this);
+    SwitchToState(READING);
 }
 
 void
@@ -809,8 +808,8 @@
 void
 ThreeGppHttpClient::SwitchToState(ThreeGppHttpClient::State_t state)
 {
-    const std::string oldState = GetStateString();
-    const std::string newState = GetStateString(state);
+    const auto oldState = GetStateString();
+    const auto newState = GetStateString(state);
     NS_LOG_FUNCTION(this << oldState << newState);
 
     if ((state == EXPECTING_MAIN_OBJECT) || (state == EXPECTING_EMBEDDED_OBJECT))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/three-gpp-http-client.h ns-3.44/src/applications/model/three-gpp-http-client.h
--- ns-3.43/src/applications/model/three-gpp-http-client.h	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/three-gpp-http-client.h	2025-03-09 16:55:49.347370900 -0700
@@ -10,11 +10,13 @@
 #ifndef THREE_GPP_HTTP_CLIENT_H
 #define THREE_GPP_HTTP_CLIENT_H
 
+#include "source-application.h"
 #include "three-gpp-http-header.h"
 
-#include <ns3/address.h>
-#include <ns3/application.h>
-#include <ns3/traced-callback.h>
+#include "ns3/address.h"
+#include "ns3/traced-callback.h"
+
+#include <optional>
 
 namespace ns3
 {
@@ -24,8 +26,8 @@
 class ThreeGppHttpVariables;
 
 /**
- * \ingroup applications
- * \defgroup http ThreeGppHttpClientServer
+ * @ingroup applications
+ * @defgroup http ThreeGppHttpClientServer
  *
  * This traffic generator simulates web browsing traffic using the Hypertext
  * Transfer Protocol (HTTP). It consists of one or more ThreeGppHttpClient
@@ -58,7 +60,7 @@
  */
 
 /**
- * \ingroup http
+ * @ingroup http
  * Model application which simulates the traffic of a web browser. This
  * application works in conjunction with an ThreeGppHttpServer application.
  *
@@ -92,7 +94,7 @@
  * and the timestamp when the packet is transmitted (which will be used to
  * compute the delay and RTT of the packet).
  */
-class ThreeGppHttpClient : public Application
+class ThreeGppHttpClient : public SourceApplication
 {
   public:
     /**
@@ -103,16 +105,17 @@
      * ThreeGppHttpClientHelper.
      */
     ThreeGppHttpClient();
+    void SetRemote(const Address& addr) override;
 
     /**
      * Returns the object TypeId.
-     * \return The object TypeId.
+     * @return The object TypeId.
      */
     static TypeId GetTypeId();
 
     /**
      * Returns a pointer to the associated socket.
-     * \return Pointer to the associated socket.
+     * @return Pointer to the associated socket.
      */
     Ptr<Socket> GetSocket() const;
 
@@ -137,39 +140,39 @@
 
     /**
      * Returns the current state of the application.
-     * \return The current state of the application.
+     * @return The current state of the application.
      */
     State_t GetState() const;
 
     /**
      * Returns the current state of the application in string format.
-     * \return The current state of the application in string format.
+     * @return The current state of the application in string format.
      */
     std::string GetStateString() const;
 
     /**
      * Returns the given state in string format.
-     * \param state An arbitrary state of an application.
-     * \return The given state equivalently expressed in string format.
+     * @param state An arbitrary state of an application.
+     * @return The given state equivalently expressed in string format.
      */
     static std::string GetStateString(State_t state);
 
     /**
      * Common callback signature for `ConnectionEstablished`, `RxMainObject`, and
      * `RxEmbeddedObject` trace sources.
-     * \param httpClient Pointer to this instance of ThreeGppHttpClient,
+     * @param httpClient Pointer to this instance of ThreeGppHttpClient,
      *                               which is where the trace originated.
      */
     typedef void (*TracedCallback)(Ptr<const ThreeGppHttpClient> httpClient);
 
     /**
      * Callback signature for `RxPage` trace sources.
-     * \param httpClient Pointer to this instance of ThreeGppHttpClient,
+     * @param httpClient Pointer to this instance of ThreeGppHttpClient,
      *                               which is where the trace originated.
-     * \param time Elapsed time from the start to the end of the request.
-     * \param numObjects Number of objects downloaded, including main and
+     * @param time Elapsed time from the start to the end of the request.
+     * @param numObjects Number of objects downloaded, including main and
      *                                                  embedded objects.
-     * \param numBytes Total number of bytes included in the page.
+     * @param numBytes Total number of bytes included in the page.
      */
     typedef void (*RxPageTracedCallback)(Ptr<const ThreeGppHttpClient> httpClient,
                                          const Time& time,
@@ -183,36 +186,42 @@
     void StartApplication() override;
     void StopApplication() override;
 
+    /**
+     * @brief set the remote port (temporary function until deprecated attributes are removed)
+     * @param port remote port
+     */
+    void SetPort(uint16_t port);
+
     // SOCKET CALLBACK METHODS
 
     /**
      * Invoked when a connection is established successfully on #m_socket. This
      * triggers a request for a main object.
-     * \param socket Pointer to the socket where the event originates from.
+     * @param socket Pointer to the socket where the event originates from.
      */
     void ConnectionSucceededCallback(Ptr<Socket> socket);
     /**
      * Invoked when #m_socket cannot establish a connection with the web server.
      * Simulation will stop and error will be raised.
-     * \param socket Pointer to the socket where the event originates from.
+     * @param socket Pointer to the socket where the event originates from.
      */
     void ConnectionFailedCallback(Ptr<Socket> socket);
     /**
      * Invoked when connection between #m_socket and the web sever is terminated.
      * Error will be logged, but simulation continues.
-     * \param socket Pointer to the socket where the event originates from.
+     * @param socket Pointer to the socket where the event originates from.
      */
     void NormalCloseCallback(Ptr<Socket> socket);
     /**
      * Invoked when connection between #m_socket and the web sever is terminated.
      * Error will be logged, but simulation continues.
-     * \param socket Pointer to the socket where the event originates from.
+     * @param socket Pointer to the socket where the event originates from.
      */
     void ErrorCloseCallback(Ptr<Socket> socket);
     /**
      * Invoked when #m_socket receives some packet data. Fires the `Rx` trace
      * source and triggers ReceiveMainObject() or ReceiveEmbeddedObject().
-     * \param socket Pointer to the socket where the event originates from.
+     * @param socket Pointer to the socket where the event originates from.
      */
     void ReceivedDataCallback(Ptr<Socket> socket);
 
@@ -220,7 +229,7 @@
 
     /**
      * Initialize #m_socket to connect to the destination web server at
-     * #m_remoteServerAddress and #m_remoteServerPort and set up callbacks to
+     * #m_peer and #m_peerPort and set up callbacks to
      * listen to its event. Invoked upon the start of the application.
      */
     void OpenConnection();
@@ -264,8 +273,8 @@
      * fires the `RxMainObject`, `RxDelay`, and `RxRtt` trace sources. The client
      * then triggers EnterParsingTime().
      *
-     * \param packet The received packet.
-     * \param from Address of the sender.
+     * @param packet The received packet.
+     * @param from Address of the sender.
      */
     void ReceiveMainObject(Ptr<Packet> packet, const Address& from);
     /**
@@ -287,8 +296,8 @@
      * (#m_embeddedObjectsToBeRequested) the client can either trigger
      * RequestEmbeddedObject() or EnterReadingTime().
      *
-     * \param packet The received packet.
-     * \param from Address of the sender.
+     * @param packet The received packet.
+     * @param from Address of the sender.
      */
     void ReceiveEmbeddedObject(Ptr<Packet> packet, const Address& from);
     /**
@@ -300,7 +309,7 @@
      * This method is invoked as a sub-procedure of ReceiveMainObject() and
      * ReceiveEmbeddedObject().
      *
-     * \param packet The received packet. If it is the first packet of the object,
+     * @param packet The received packet. If it is the first packet of the object,
      *               then it must have a ThreeGppHttpHeader attached to it.
      */
     void Receive(Ptr<Packet> packet);
@@ -341,7 +350,7 @@
 
     /**
      * Change the state of the client. Fires the `StateTransition` trace source.
-     * \param state The new state.
+     * @param state The new state.
      */
     void SwitchToState(State_t state);
 
@@ -376,12 +385,8 @@
 
     /// The `Variables` attribute.
     Ptr<ThreeGppHttpVariables> m_httpVariables;
-    /// The `RemoteServerAddress` attribute. The address of the web server.
-    Address m_remoteServerAddress;
     /// The `RemoteServerPort` attribute.
-    uint16_t m_remoteServerPort;
-    /// The `Tos` attribute.
-    uint8_t m_tos;
+    std::optional<uint16_t> m_peerPort;
 
     // TRACE SOURCES
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/three-gpp-http-header.cc ns-3.44/src/applications/model/three-gpp-http-header.cc
--- ns-3.43/src/applications/model/three-gpp-http-header.cc	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/three-gpp-http-header.cc	2025-03-09 16:55:49.347370900 -0700
@@ -9,8 +9,8 @@
 
 #include "three-gpp-http-header.h"
 
-#include <ns3/log.h>
-#include <ns3/packet.h>
+#include "ns3/log.h"
+#include "ns3/packet.h"
 
 #include <sstream>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/three-gpp-http-header.h ns-3.44/src/applications/model/three-gpp-http-header.h
--- ns-3.43/src/applications/model/three-gpp-http-header.h	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/three-gpp-http-header.h	2025-03-09 16:55:49.347370900 -0700
@@ -10,8 +10,8 @@
 #ifndef THREE_GPP_HTTP_HEADER_H
 #define THREE_GPP_HTTP_HEADER_H
 
-#include <ns3/header.h>
-#include <ns3/nstime.h>
+#include "ns3/header.h"
+#include "ns3/nstime.h"
 
 namespace ns3
 {
@@ -19,8 +19,8 @@
 class Packet;
 
 /**
- * \ingroup http
- * \brief Header used by web browsing applications to transmit information about
+ * @ingroup http
+ * @brief Header used by web browsing applications to transmit information about
  *        content type, content length and timestamps for delay statistics.
  *
  * The header contains the following fields (and their respective size when
@@ -48,7 +48,7 @@
 
     /**
      * Returns the object TypeId.
-     * \return The object TypeId.
+     * @return The object TypeId.
      */
     static TypeId GetTypeId();
 
@@ -62,7 +62,7 @@
     void Print(std::ostream& os) const override;
 
     /**
-     * \return The string representation of the header.
+     * @return The string representation of the header.
      */
     std::string ToString() const;
 
@@ -75,42 +75,42 @@
     };
 
     /**
-     * \param contentType The content type.
+     * @param contentType The content type.
      */
     void SetContentType(ContentType_t contentType);
 
     /**
-     * \return The content type.
+     * @return The content type.
      */
     ContentType_t GetContentType() const;
 
     /**
-     * \param contentLength The content length (in bytes).
+     * @param contentLength The content length (in bytes).
      */
     void SetContentLength(uint32_t contentLength);
 
     /**
-     * \return The content length (in bytes).
+     * @return The content length (in bytes).
      */
     uint32_t GetContentLength() const;
 
     /**
-     * \param clientTs The client time stamp.
+     * @param clientTs The client time stamp.
      */
     void SetClientTs(Time clientTs);
 
     /**
-     * \return The client time stamp.
+     * @return The client time stamp.
      */
     Time GetClientTs() const;
 
     /**
-     * \param serverTs The server time stamp.
+     * @param serverTs The server time stamp.
      */
     void SetServerTs(Time serverTs);
 
     /**
-     * \return The server time stamp.
+     * @return The server time stamp.
      */
     Time GetServerTs() const;
 
